import React from 'react'
import moment from 'moment'

class Players extends React.Component {
  constructor() {
    super()
    this.handleChange = this.handleChange.bind(this)
  }

  componentDidMount () {
    console.log('Players did mount', this)
    const { matchesGetPlayersRequest } = this.props.matchesActions
    matchesGetPlayersRequest()
  }

  handleChange (event) {
    event.preventDefault()
    const { matchesSetFilter } = this.props.matchesActions
    const nextFilter = {
      category: this.category.value,
      player: this.player.value,
      junior: this.junior.checked,
      paid: this.paid.checked,
      matchfilter: this.matchfilter.checked
    }
    matchesSetFilter(nextFilter)
  }

  render () {
    const state = this.props.matches
    console.log('sali', state)
    const actions = this.props.matchesActions
    const { players, filteredPlayers, filter } = state

    return (
      <div>
        <form>
          <p>{filteredPlayers.length}/{players.length} Spieler, {}/{} Kategorien, {}/{} Daten, {}/{} Zeiten, {}/{} Orte</p>
          <label for="matchfilter">Match Filter benutzen</label>
          <input type="checkbox" ref={(input) => {this.matchfilter = input}} id="matchfilter" checked={filter.matchfilter} onChange={this.handleChange} />
          <table className='table table-bordered table-striped'>
            <thead>
              <tr>
                <th>Name</th><th>Kategorie</th><th>Telefon</th><th>E-Mail</th><th>Junior</th><th>Bezahlt</th>
              </tr>
              <tr>
                <td>
                  <input type="input" ref={(input) => {this.player = input}} id="player" value={filter.player} placeholder="Name" onChange={this.handleChange}></input>
                </td>
                <td>
                  <input type="input" ref={(input) => {this.category = input}} id="category" value={filter.category} placeholder="Datum" onChange={this.handleChange}></input>
                </td>
                <td>
                </td>
                <td>
                </td>
                <td>
                  <input type="checkbox" ref={(input) => {this.junior = input}} id="junior" checked={filter.junior} placeholder="Spieler" onChange={this.handleChange}></input>
                </td>
                <td>
                  <input type="checkbox" ref={(input) => {this.paid = input}} id="paid" checked={filter.paid} placeholder="Resultat" onChange={this.handleChange}></input>
                </td>
              </tr>
            </thead>
            <tbody>
              {filteredPlayers.map((player, key) => 
              <tr key={key}>
                <td>{player.fullName}</td>
                <td>{player.category}</td>
                <td>{player.phone}</td>
                <td>{player.email}</td>
                <td>{player.junior ? '\u2713' : '\u2717'}</td>
                <td>{player.paid ? '\u2713' : '\u2717'}</td>
              </tr>
              )}
            </tbody>
          </table>
        </form>
      </div>
    )
  }
}

export default Players
